<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column align="center" :label="$t('row.owner')">
        <template slot-scope="scope">
          <span>{{ scope.row.user }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.province')">
        <template slot-scope="scope">
          <span>{{ scope.row.province }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.city')">
        <template slot-scope="scope">
          <span>{{ scope.row.city }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.address')">
        <template slot-scope="scope">
          <span>{{ scope.row.address }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.region')">
        <template slot-scope="scope">
          <span>{{ scope.row.region }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.subscriptionNumber')">
        <template slot-scope="scope">
          <span>{{ $t('form.' + scope.row.request_status) }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('row.operation')" width="350px">
        <template slot-scope="scope">
          <span v-if="scope.row.request_status === 'pending'" class="pointer mr-1 ml-1 fa fa-check" @click="validateCounter(scope.row.request_id)">&nbsp;</span>
          <span class="pointer mr-1 ml-1 fa fa-edit" @click="editCounter(scope.row.id)">&nbsp;</span>
          <span class="pointer mr-1 ml-1 fa fa-code" @click="showAction(scope.row.id)">&nbsp;</span>
          <span class="pointer mr-1 ml-1 fa fa-history" @click="showHistory(scope.row.id)">&nbsp;</span>
          <span v-if="scope.row.request_status !== 'pending'" class="pointer mr-1 ml-1 fa fa-remove" @click="removeCounter(scope.row.request_id)">&nbsp;</span>
        </template>
      </el-table-column>

    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />

    <el-dialog :title="$t('user.validateUserForm')" :visible.sync="validateUserFormVisible">
      <div v-loading="validateLoading" class="form-container">
        <b-form-input v-model="validateCounterData.verification_code" name="title" type="text" :placeholder="$t('user.validateUserForm')" required />
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="validateUserFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="handleVerification()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>

    <el-dialog :title="$t('user.validateUserForm')" :visible.sync="editUserFormVisible">
      <div v-loading="validateLoading" class="form-container">
        <b-form-select v-model="editCounterData.counterType" :options="options">&nbsp;</b-form-select>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="editUserFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="handleEdit()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>

    <el-dialog :title="$t('form.assignmentCounter')" :visible.sync="showActionFormVisible">
      <el-table v-loading="listLoadingAction" :data="listAction" border fit highlight-current-row style="width: 100%">
        <el-table-column align="center" :label="$t('row.title')">
          <template slot-scope="scope">
            <span>{{ scope.row.title }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('row.explain')">
          <template slot-scope="scope">
            <span>{{ scope.row.explain }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('form.date')">
          <template slot-scope="scope">
            <span>{{ scope.row.date }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('form.deadline')">
          <template slot-scope="scope">
            <span>{{ scope.row.deadline }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('form.status')">
          <template slot-scope="scope">
            <span>{{ scope.row.status }}</span>
          </template>
        </el-table-column>

      </el-table>
    </el-dialog>

    <el-dialog :title="$t('form.assignmentHistory')" :visible.sync="showHistoryFormVisible">
      <el-table v-loading="listLoadingHistory" :data="listHistory" border fit highlight-current-row style="width: 100%">
        <el-table-column align="center" :label="$t('row.owner')">
          <template slot-scope="scope">
            <span>{{ scope.row.user }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('row.filePath')">
          <template slot-scope="scope">
            <span>{{ scope.row.file_path }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('form.valueContour')">
          <template slot-scope="scope">
            <span>{{ scope.row.value }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('form.date')">
          <template slot-scope="scope">
            <span>{{ scope.row.date }}</span>
          </template>
        </el-table-column>

        <el-table-column align="center" :label="$t('row.operation')">
          <template slot-scope="scope">
            <span class="pointer mr-1 ml-1 fa fa-edit" @click="setValue(scope.row.file_path, scope.row.value, scope.row.id)">&nbsp;</span>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>

    <el-dialog :title="$t('row.readContour')" :visible.sync="dialogReadContour">
      <div class="form-container">
        <el-form ref="readContour" :model="readContour" label-position="left" class="register-form" style="max-width: 500px;">
          <el-input v-model="readContour.id" hidden />
          <div class="mb-1">
            {{ $t('row.readContour') }}
          </div>
          <div class="mb-3">
            <img :src="readContour.path" style="width: 250px">
          </div>
          <div class="mb-1">
            {{ $t('row.readContour') }}
          </div>
          <div class="mb-3">
            <input v-model="readContour.value" type="text" :placeholder="$t('row.readContour')">
          </div>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="submitContour(readContour.id)">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Address from '@/api/address';
import Bani from '@/api/bani';
import 'vue-select/src/scss/vue-select.scss';

const addresResource = new Address('address');
const baniResource = new Bani('bani');
// import i18n from '@/lang';

export default {
  name: 'AddressList',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      listAction: null,
      listHistory: null,
      total: 0,
      request: {},
      readContour: {},
      listLoading: true,
      dialogReadContour: false,
      listLoadingAction: true,
      listLoadingHistory: false,
      validateCounterData: {},
      editCounterData: {},
      action: {},
      showActionFormVisible: false,
      showHistoryFormVisible: false,
      validateUserFormVisible: false,
      editUserFormVisible: false,
      validateLoading: false,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [
        { value: 'Owner', text: this.$i18n.t(`row.owner`) },
        { value: 'Renter', text: this.$i18n.t(`row.renter`) },
        { value: 'ColleagueManager', text: this.$i18n.t(`row.colleagueManager`) },
      ],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await addresResource.myCounters(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    removeCounter(addressId) {
      this.request.addressId = addressId;
      this.$confirm(this.$i18n.t(`dialog.isDelete`), this.$i18n.t(`dialog.confirm`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'warning',
      })
        .then(async() => {
          const result = await addresResource.removeCounter(this.request);
          if (result.success === true) {
            this.getList();
          }
        })
        .catch(err => {
          console.error(err);
        });
    },
    submitContour(id) {
      const result = baniResource.submitContour(this.readContour);
      if (result.success === true) {
        this.getHistory();
        this.dialogReadContour = false;
      } else {
        this.getHistory();
        this.dialogReadContour = false;
      }
    },
    setValue(path, value, id) {
      this.readContour.path = path;
      this.readContour.value = value;
      this.readContour.id = id;
      this.dialogReadContour = true;
    },
    validateCounter(id) {
      this.validateCounterData.id = id;
      this.validateUserFormVisible = true;
    },
    showAction(id) {
      this.action.id = id;
      this.showActionFormVisible = true;
      this.getAction();
    },
    async getAction() {
      this.listLoadingAction = true;
      const { result } = await addresResource.getActions(this.action);
      this.listAction = result.rows;
      this.listLoadingAction = false;
    },
    showHistory(id) {
      this.action.id = id;
      this.showHistoryFormVisible = true;
      this.listLoadingHistory = true;
      this.getHistory();
      this.listLoadingHistory = false;
    },
    async getHistory() {
      this.listLoadingAction = true;
      const { actions } = await addresResource.getHistory(this.action);
      this.listHistory = actions;
      this.listLoadingAction = false;
    },
    editCounter(id) {
      this.editCounterData.id = id;
      this.editUserFormVisible = true;
    },
    handleVerification() {
      const result = addresResource.handleVerification(this.validateCounterData);
      if (result.success === true) {
        this.validateUserFormVisible = false;
        this.query.page = 1;
        this.getList();
      }
      this.validateCounterData = {};
      this.validateUserFormVisible = false;
      this.query.page = 1;
      this.getList();
    },
    handleEdit() {
      const result = addresResource.editCounter(this.editCounterData);
      if (result.success === true) {
        this.getList();
      }
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>

<style>
  .login-container{
    background: url(/images/login-bg.jpg) no-repeat center center;
    -webkit-background-size: cover;
    background-size: cover;
  }
  .el-dialog {
    width: 50% !important;
  }
</style>
<style rel="stylesheet/scss" lang="scss">
  $bg:#FFF;
  $light_gray:#eee;

  /* reset element-ui css */
  .login-container {
    .el-input {
      display: inline-block;
      height: 47px;
      width: 85%;
      input {
        background: transparent;
        border: 0px;
        -webkit-appearance: none;
        border-radius: 0px;
        padding: 12px 5px 12px 15px;
        color: #999;
        height: 47px;
        &:-webkit-autofill {
          -webkit-box-shadow: 0 0 0px 1000px $bg inset !important;
          -webkit-text-fill-color: #000 !important;
        }
      }
    }
    .el-form-item {
      border: none;
      background: rgba(0, 0, 0, 0.1);
      border-radius: 5px;
      color: #454545;
    }
  }
  .el-form-item {
    margin-bottom: 2px !important;
  }
</style>

<style rel="stylesheet/scss" lang="scss" scoped>
  $bg:#FFF;
  $dark_gray:#889aa4;
  $light_gray:#eee;
  .login-container {
    position: fixed;
    height: 100%;
    width: 100%;
    background-color: $bg;
    .login-form {
      position: absolute;
      left: 0;
      right: 0;
      width: 520px;
      max-width: 100%;
      padding: 15px 5px 15px 5px;
      margin: 120px auto;
      /*height: 550px;*/
      border-radius: 0px;
    }
    .tips {
      font-size: 14px;
      color: #fff;
      margin-bottom: 10px;
      span {
        &:first-of-type {
          margin-right: 16px;
        }
      }
    }
    .svg-container {
      padding: 6px 5px 6px 15px;
      color: $dark_gray;
      vertical-align: middle;
      width: 30px;
      display: inline-block;
    }
    .title {
      height: 40px;
      line-height: 40px;
      font-size: 26px;
      font-weight: 400;
      color: $light_gray;
      margin: 0px auto 40px auto;
      text-align: center;
      font-weight: bold;
    }
    .show-pwd {
      position: absolute;
      right: 10px;
      top: 7px;
      font-size: 16px;
      color: $dark_gray;
      cursor: pointer;
      user-select: none;
    }
    .sms-pwd{
      position: absolute;
      top: 7px;
      cursor: pointer;
      user-select: none;
    }
    .set-language {
      color: #fff;
      position: absolute;
      top: 40px;
      right: 35px;
    }
  }

  .el-dialog__headerbtn{
    padding: 5px !important;
    border: 1px solid #aaa !important;
    border-radius: 5px !important;
    position: relative !important;
    top: -30px !important;
    right: -10px !important;
    background: #ffff !important;
  }
  .el-dialog__header{
    border-bottom: 1px solid #ddd !important;
  }
  .timer{
    color: red;
    display: contents;
  }
  .new-button {
    display: inline-block;
    padding: 8px 12px;
    cursor: pointer;
    border-radius: 4px;
    background-color: #3369ab;
    font-size: 16px;
    color: #fff;
  }
  input[type="file"] {
    position: absolute;
    z-index: -1;
    top: 6px;
    left: 0;
    font-size: 15px;
    color: rgb(153,153,153);
  }
  .button-wrap {
    position: relative;
  }
</style>
